const DEBUG = true;

const CHROME =
    /Chrome/.test(navigator.userAgent) && /Google Inc/.test(navigator.vendor);

function getFileName() {
    return CHROME ? (new Error().stack.split('\n').slice(3, 4).join('\n').split('.js')[0].split('/').reverse()[0]).toUpperCase() : (new Error().stack.split('\n').slice(2, 3).join('\n').split('.js')[0].split('/').reverse()[0]).toUpperCase()
}

function getLink() {
    return CHROME ? new Error().stack.split('\n').slice(3).join('\n') : new Error().stack.split('\n').slice(2).join('\n')
}

export function debug() {
    let date = new Date().toTimeString(`HH:mm:ss`).replace(/\ .+/, ``)
    let args = Array.prototype.slice.call(arguments)
    args.unshift(`%c [DEBUG] ${date}`, 'color: SeaGreen;')
    DEBUG && console.groupCollapsed(`%c [DEBUG][${getFileName()}]`, 'color: SeaGreen;', date)
    DEBUG && args.slice(2).map(arg => console.log(arg))
    DEBUG && console.groupEnd()
}

export function info() {
    let date = new Date().toTimeString(`HH:mm:ss`).replace(/\ .+/, ``)
    let args = Array.prototype.slice.call(arguments)
    args.unshift(`%c [INFO] ${date}`, 'color: DeepSkyBlue;')
    DEBUG && console.groupCollapsed(`%c [INFO][${getFileName()}]`, 'color: DeepSkyBlue;', date)
    DEBUG && args.slice(2).map(arg => console.log(arg))
    // DEBUG && console.log.apply(console, args.slice(2))
    DEBUG && console.groupEnd()
}

export function warn() {
    let date = new Date().toTimeString(`HH:mm:ss`).replace(/\ .+/, ``)
    let args = Array.prototype.slice.call(arguments)
    args.unshift(`%c [WARN] ${date}`, 'color: DarkOrange;')
    DEBUG && console.groupCollapsed(`%c [WARN][${getFileName()}]`, 'color: DarkOrange;', date)
    DEBUG && args.slice(2).map(arg => console.log(arg))
    DEBUG && console.log(`%c${getLink()}`, 'color: DarkOrange;')
    DEBUG && console.groupEnd()
}

export function error() {
    let date = new Date().toTimeString(`HH:mm:ss`).replace(/\ .+/, ``)
    let args = Array.prototype.slice.call(arguments)
    args.unshift(`%c [ERROR] ${date}`, 'color: Tomato;')
    DEBUG && console.groupCollapsed(`%c [ERROR][${getFileName()}]`, 'color: Tomato;', date)
    DEBUG && args.slice(2).map(arg => console.log(arg))
    DEBUG && console.log(`%c${getLink()}`, 'color: Tomato;')
    DEBUG && console.groupEnd()
}

export function todo() {
    let date = new Date().toTimeString(`HH:mm:ss`).replace(/\ .+/, ``)
    let args = Array.prototype.slice.call(arguments)
    args.unshift(`%c [TODO] ${date}`, 'color: Gold;')
    DEBUG && console.groupCollapsed(`%c [TODO][${getFileName()}]`, 'color: Gold;', date)
    DEBUG && args.slice(2).map(arg => console.log(arg))
    DEBUG && console.log(`%c${getLink()}`, 'color: Gold;')
    DEBUG && console.groupEnd()
}

export function note() {
    let date = new Date().toTimeString(`HH:mm:ss`).replace(/\ .+/, ``)
    let args = Array.prototype.slice.call(arguments)
    args.unshift(`%c [NOTE] ${date}`, 'color: Cyan;')
    DEBUG && console.groupCollapsed(`%c [NOTE][${getFileName()}]`, 'color: Cyan;', date)
    DEBUG && args.slice(2).map(arg => console.log(arg))
    DEBUG && console.log(`%c${getLink()}`, 'color: Cyan;')
    DEBUG && console.groupEnd()
}

import { LitElement, html } from 'lit-element'

export class DebugData extends LitElement {
    static get properties() {
        return {
            data: { type: Object }
        }
    }
    constructor() {
        super()
        this.data = { name: "hamed" }

    }
    render() {
        return html`
            <style>
                ::slotted(*) {
                    pointer-events: none;
                }
            </style>
            <pre>
                ${(() => {
                    return typeof this.data === 'object' ? JSON.stringify(this.data, null, 2) : this.data
                })()}
            </pre>
        `
    }
}

customElements.define('debug-data', DebugData)
